<?php
/*
Plugin Name: DailyFratze Widget
Description: Adds a fratze to your sidebar
Author: Michael Simons
Version: 0.5
Author URI: http://michael-simons.eu

Changelog
0.3 -> 0.4
	removed base64 encoding of image data as it is not supported in ie
0.4 -> 0.4a
	cached the image
0.4a -> 0.4b
	removed the port from the generated link
0.4b -> 0.5
	added the option to include a css class on the generated image tag
0.5 -> 0.5a
	new rss urls
*/

function dailyfratze_latest_fratze() {
    dailyfratze_private_doit(get_option('widget_dailyfratze'));
}
function startElement($parser, $name, $attrs) 
{
    global $depth;
    for ($i = 0; $i < $depth[$parser]; $i++) {
        echo "  ";
    }
print_r($attrs);
    echo "$attrs\n";
    $depth[$parser]++;
}

function endElement($parser, $name) 
{
    global $depth;
    $depth[$parser]--;
}
function characterData($parser, $data) 
{
    echo $data;
}


function dailyfratze_charts($new_col = "#333333", $old_col = "#DDDDDD") {
	set_magic_quotes_runtime(0);
	
	$max_time = 4 * 60 * 60 ; 

	$r_new = hexdec(substr($new_col, 1, 2));
	$r_old = hexdec(substr($old_col, 1, 2));
	$r_range = ($r_old-$r_new);
	
	$g_new = hexdec(substr($new_col, 3, 2));
	$g_old = hexdec(substr($old_col, 3, 2));
	$g_range = ($g_old-$g_new);

	$b_new = hexdec(substr($new_col, 5, 2));
	$b_old = hexdec(substr($old_col, 5, 2));
	$b_range = ($b_old-$b_new);
	
	$options = get_option('widget_dailyfratze');
	
	require_once(ABSPATH . WPINC . '/rss.php');
    define('MAGPIE_CACHE_ON',  false);			
    $fratzenschneider = $options['fratzenschneider'];			               
  	$feed = fetch_rss("http://dailyfratze.de/feeds/recentlyplayed/" . $fratzenschneider);

	foreach ($feed->items as $item) {
		$content = $item['atom_content'];
		
		$d = array();				
		// MagPIE doesn't parse atom_content... lame ass thingy
		if (preg_match("/<track_title\s*>(.*)<\/track_title>\s*<track_artist\s*>(.*)<\/track_artist>\s*<track_album\s*>(.*)<\/track_album>\s*/u", $content, $d)) {
			$played = parse_RFC3339($item['published']);
			$diff = time() - $played;
			$r = round($diff/$max_time*($r_range))+$r_new; 
			$r = clamp(min($r_new, $r_old), max($r_new, $r_old), $r);
			$g = round($diff/$max_time*($g_range))+$g_new; 
			$g = clamp(min($g_new, $g_old), max($g_new, $g_old), $g);
			$b = round($diff/$max_time*($b_range))+$b_new; 
			$b = clamp(min($b_new, $b_old), max($b_new, $b_old), $b);
			$r_hex = str_pad(dechex($r), 2, '0', STR_PAD_LEFT);
			$g_hex = str_pad(dechex($g), 2, '0', STR_PAD_LEFT);
			$b_hex = str_pad(dechex($r), 2, '0', STR_PAD_LEFT);
			$colstr = " style=\"color: #".$r_hex.$g_hex.$b_hex.";\"";			
			
			$title = "title=\"vom Album $d[3] zuletzt gespielt vor " . time_since($played) . '"';
			echo "<li $colstr $title><small>$d[2] - $d[1]</small></li>";
		}
	}
}

function widget_dailyfratze_init() {
	function widget_dailyfratze($args) {
		extract($args);
                		
        $options = get_option('widget_dailyfratze');
        $title   = $options['title'];			  	
        echo $before_widget . $before_title . $title . $after_title;
        dailyfratze_private_doit($options);
        echo $after_widget;		
	}

	function widget_dailyfratze_control() {
		$options = get_option('widget_dailyfratze');
		if ( !is_array($options) )
			$options = array('title'=>'', 'fratzenschneider'=>'', 'size'=>'small', 'width'=>'');
		if ( $_POST['dailyfratze-submit'] ) {
			dailyfratze_private_retrive_option_input($options);
		}		
						
		dailyfratze_private_echo_option_input($options);
	}
	
	register_sidebar_widget(array('DailyFratze.de', 'widgets'), 'widget_dailyfratze');		
	register_widget_control(array('DailyFratze.de', 'widgets'), 'widget_dailyfratze_control', 300, 175);
}

function plugin_dailyfratze_options() {
	if (function_exists('add_options_page')) {
    	add_options_page('DailyFratze.de', 'DailyFratze.de', 0, basename(__FILE__), 'dailyfratze_private_options_subpanel');
	}
}

function dailyfratze_private_echo_option_input($options) {
    $title            = htmlspecialchars($options['title'], ENT_QUOTES);
	$fratzenschneider = htmlspecialchars($options['fratzenschneider'], ENT_QUOTES);
    $size             = htmlspecialchars($options['size'],  ENT_QUOTES);
    $width            = htmlspecialchars($options['width'], ENT_QUOTES);
    $css              = htmlspecialchars($options['css'],   ENT_QUOTES);
	?>
	<table>
		<tr>
			<td><label for="dailyfratze-title">Titel</label></td>
			<td><input style="width: 200px;" id="dailyfratze-title" name="dailyfratze-title" type="text" title="Only used for the widget" value="<?php echo $title ; ?>" /></td>
		</tr>
		<tr>
			<td><label for="dailyfratze-fratzenschneider">Fratze</label></td>
			<td><input style="width: 200px;" id="dailyfratze-fratzenschneider" name="dailyfratze-fratzenschneider" type="text" value="<?php echo $fratzenschneider; ?>" /></td>
		</tr>
		<tr>
			<td><label for="dailyfratze-size"><?php echo __('Originalsize'); ?></label></td>
			<td>
				<select name="dailyfratze-size">
					<option value="small" <?php echo $size == 'small' ? 'selected="selected"' : ''; ?>><?php echo __('Small'); ?></option>
					<option value="big"   <?php echo $size == 'big'   ? 'selected="selected"' : ''; ?>><?php echo __('Big'); ?></option>
	    	</select>
			</td>
		</tr>
		<tr>
			<td><label for="dailyfratze-width">Imagewidth</label></td>
			<td><input style="width: 200px;" id="dailyfratze-width" name="dailyfratze-width" type="text" value="<?php echo $width; ?>" /></td>
		</tr>
		<tr>
			<td><label for="dailyfratze-css">CSS Klasse fürs Bild</label></td>
			<td><input style="width: 200px;" id="dailyfratze-css" name="dailyfratze-css" type="text" value="<?php echo $css; ?>" /></td>
		</tr>
	</table>
	<?php 
	echo '<input type="hidden" id="dailyfratze-submit" name="dailyfratze-submit" value="1" />';
}

function dailyfratze_private_retrive_option_input($options) {
	$options['title']            = strip_tags(stripslashes($_POST['dailyfratze-title']));			
	$options['fratzenschneider'] = strip_tags(stripslashes($_POST['dailyfratze-fratzenschneider']));			
	$options['size']             = strip_tags(stripslashes($_POST['dailyfratze-size']));
	$options['width']            = strip_tags(stripslashes($_POST['dailyfratze-width']));
	$options['css']              = strip_tags(stripslashes($_POST['dailyfratze-css']));	
	
	update_option('widget_dailyfratze', $options);                
}

function dailyfratze_private_doit($options) {        
    set_magic_quotes_runtime(0);

    require_once(ABSPATH . WPINC . '/rss.php');
    define('MAGPIE_CACHE_ON',  true);			
    $fratzenschneider = $options['fratzenschneider'];			               
	$width            = $options['width'];	
	$css              = $options['css'];
    $fratzen = fetch_rss("http://dailyfratze.de/feeds/fratzen/" . $fratzenschneider);	
    foreach ($fratzen->items as $item) 
	    $pics[] = array(
	                'big' => $item['link_image_big'], 
	                'small' => $item['link_image_small'],
	                'title' => $item['title'],
			'id'    => preg_replace('/:\d+\//', '/', substr($item['id'], 0, strrpos($item['id'], '/')))
	              );							
    $i = 0;
    $fname = $pics[$i][$options['size'] == '' || $options['size'] == null ? 'small' : $options['size']];
    	
	$cacheDirectory = ABSPATH . 'wp-content/cache/';
	$cacheFile      = 'dailyfratze.cache.jpg';
	$cacheTime      = 3600; 
	
	$cachefile_created = @file_exists($cacheDirectory . $cacheFile) ? @filemtime($cacheDirectory . $cacheFile) : 0;
	
	if (time() - $cacheTime > $cachefile_created) {
	   	$myFile = fopen($cacheDirectory . $cacheFile, "w");
		fwrite($myFile, file_get_contents($fname));			
		fclose($myFile);
	}

    echo '<a href="' . $pics[$i]['id']. '">';		
	echo '<img class="' . $css . '" src="' .get_option('siteurl') . '/wp-content/cache/' . $cacheFile . '" alt="'. $pics[$i]['title']  .'" title="' .$pics[$i]['title'] . '"' . ($width != '' ? 'width="' . $width . '" ' : '') .   '/>';
//	echo '<img src="data:image/jpeg;base64,' . base64_encode(file_get_contents($fname)) . '" alt="'. $pics[$i]['title']  .'" title="' .$pics[$i]['title'] . '"' . ($width != '' ? 'width="' . $width . '" ' : '') .   '/>';
	echo '</a>';
}

function dailyfratze_private_options_subpanel() {
    $options = get_option('widget_dailyfratze');
	if ( !is_array($options) )
		$options = array('title'=>'', 'fratzenschneider'=>'', 'size'=>'small', 'width'=>'');   
    if (isset($_POST['info_update'])) {
        ?><div class="updated"><p><strong><?php 
		dailyfratze_private_retrive_option_input(&$options);
        _e('Done.');
        ?></strong></p></div><?php
    } ?>
    
    <div class=wrap>
    <form method="post">
        <h2>DailyFratze Options</h2>
        <fieldset name="set1">
        <?php dailyfratze_private_echo_option_input($options); ?>
        </fieldset>     
        <div class="submit">
            <input type="submit" name="info_update" value="<?php
            _e('Update options')
            ?>" /></div>
    </form>
    </div><?php
}

function parse_RFC3339($rfc3339) {
	$tmp = str_replace( "T", " ", $rfc3339); // Remove the T
	$tmp = ereg_replace("(\.[0-9]{1,})?", "", $tmp); // Remove the decimal and any numbers after it

	$datetime = substr($tmp, 0, 19);  // Grab the datetime part of the string
	$timezone = str_replace(":", "", substr($tmp, 19, 6)); // Grab the timezone, (-/+0000) PHP 4 doesn't support the colon

	return strtotime($datetime . " " . $timezone);	
}

add_action('widgets_init', 'widget_dailyfratze_init');
add_action('admin_menu', 'plugin_dailyfratze_options');
?>